/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.99 Revision 1.130
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.99 2010/07/06 18:55:50 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.130 2012/03/22 19:16:22 vapier Exp $
4 4
5# @ECLASS: autotools.eclass 5# @ECLASS: autotools.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts 8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass is for safely handling autotooled software packages that need to 10# This eclass is for safely handling autotooled software packages that need to
11# regenerate their build scripts. All functions will abort in case of errors. 11# regenerate their build scripts. All functions will abort in case of errors.
12# 12
13# NB: If you add anything, please comment it! 13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
14 18
15inherit eutils libtool 19inherit eutils libtool
16 20
17# @ECLASS-VARIABLE: WANT_AUTOCONF 21# @ECLASS-VARIABLE: WANT_AUTOCONF
18# @DESCRIPTION: 22# @DESCRIPTION:
22# @ECLASS-VARIABLE: WANT_AUTOMAKE 26# @ECLASS-VARIABLE: WANT_AUTOMAKE
23# @DESCRIPTION: 27# @DESCRIPTION:
24# The major version of automake your package needs 28# The major version of automake your package needs
25: ${WANT_AUTOMAKE:=latest} 29: ${WANT_AUTOMAKE:=latest}
26 30
31# @ECLASS-VARIABLE: WANT_LIBTOOL
32# @DESCRIPTION:
33# Do you want libtool? Valid values here are "latest" and "none".
34: ${WANT_LIBTOOL:=latest}
35
27# @ECLASS-VARIABLE: _LATEST_AUTOMAKE 36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37# @INTERNAL
28# @DESCRIPTION: 38# @DESCRIPTION:
29# CONSTANT! 39# CONSTANT!
30# The latest major version/slot of automake available on each arch. 40# The latest major version/slot of automake available on each arch. #312315
31# If a newer version is stable on any arch, and is NOT reflected in this list, 41# If a newer slot is stable on any arch, and is NOT reflected in this list,
32# then circular dependencies may arise during emerge @system bootstraps. 42# then circular dependencies may arise during emerge @system bootstraps.
33# Do NOT change this variable in your ebuilds! 43# Do NOT change this variable in your ebuilds!
44# If you want to force a newer minor version, you can specify the correct
45# WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
34_LATEST_AUTOMAKE='1.11' 46_LATEST_AUTOMAKE=( 1.11.1:1.11 )
35 47
36_automake_atom="sys-devel/automake" 48_automake_atom="sys-devel/automake"
37_autoconf_atom="sys-devel/autoconf" 49_autoconf_atom="sys-devel/autoconf"
38if [[ -n ${WANT_AUTOMAKE} ]]; then 50if [[ -n ${WANT_AUTOMAKE} ]]; then
39 case ${WANT_AUTOMAKE} in 51 case ${WANT_AUTOMAKE} in
40 none) _automake_atom="" ;; # some packages don't require automake at all 52 none) _automake_atom="" ;; # some packages don't require automake at all
41 # if you change the "latest" version here, change also autotools_run_tool 53 # if you change the "latest" version here, change also autotools_run_tool
42 # this MUST reflect the latest stable major version for each arch! 54 # this MUST reflect the latest stable major version for each arch!
55 latest)
56 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
57 if [[ ${EAPI:-0} != 0 ]] ; then
58 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
59 else
43 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;; 60 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
61 fi
62 ;;
44 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 63 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
45 esac 64 esac
46 export WANT_AUTOMAKE 65 export WANT_AUTOMAKE
47fi 66fi
48 67
49if [[ -n ${WANT_AUTOCONF} ]] ; then 68if [[ -n ${WANT_AUTOCONF} ]] ; then
50 case ${WANT_AUTOCONF} in 69 case ${WANT_AUTOCONF} in
51 none) _autoconf_atom="" ;; # some packages don't require autoconf at all 70 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
52 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 71 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
53 # if you change the latest version here, change also autotools_run_tool 72 # if you change the "latest" version here, change also autotools_env_setup
54 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;; 73 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
55 *) _autoconf_atom="INCORRECT-WANT_AUTOCONF-SETTING-IN-EBUILD" ;; 74 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
56 esac 75 esac
57 export WANT_AUTOCONF 76 export WANT_AUTOCONF
58fi 77fi
59 78
79_libtool_atom="sys-devel/libtool"
80if [[ -n ${WANT_LIBTOOL} ]] ; then
81 case ${WANT_LIBTOOL} in
82 none) _libtool_atom="" ;;
83 latest) ;;
84 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
85 esac
86 export WANT_LIBTOOL
87fi
88
60AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom}" 89AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
61[[ ${CATEGORY}/${PN} != "sys-devel/libtool" ]] && AUTOTOOLS_DEPEND="${AUTOTOOLS_DEPEND} >=sys-devel/libtool-2.2.6b"
62RDEPEND="" 90RDEPEND=""
63 91
64# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND 92# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
65# @DESCRIPTION: 93# @DESCRIPTION:
66# Set to 'no' to disable automatically adding to DEPEND. This lets 94# Set to 'no' to disable automatically adding to DEPEND. This lets
72fi 100fi
73 101
74unset _automake_atom _autoconf_atom 102unset _automake_atom _autoconf_atom
75 103
76# @ECLASS-VARIABLE: AM_OPTS 104# @ECLASS-VARIABLE: AM_OPTS
105# @DEFAULT_UNSET
77# @DESCRIPTION: 106# @DESCRIPTION:
78# Additional options to pass to automake during 107# Additional options to pass to automake during
79# eautoreconf call. 108# eautoreconf call.
80 109
110# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
111# @DEFAULT_UNSET
112# @DESCRIPTION:
113# Don't run eautomake command if set to 'yes'; only used to workaround
114# broken packages. Generally you should, instead, fix the package to
115# not call AM_INIT_AUTOMAKE if it doesn't actually use automake.
116
81# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE 117# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
118# @DEFAULT_UNSET
82# @DESCRIPTION: 119# @DESCRIPTION:
83# Don't run elibtoolize command if set to 'yes', 120# Don't run elibtoolize command if set to 'yes',
84# useful when elibtoolize needs to be ran with 121# useful when elibtoolize needs to be ran with
85# particular options 122# particular options
86 123
87# XXX: M4DIR should be deprecated
88# @ECLASS-VARIABLE: AT_M4DIR 124# @ECLASS-VARIABLE: AT_M4DIR
89# @DESCRIPTION: 125# @DESCRIPTION:
90# Additional director(y|ies) aclocal should search 126# Additional director(y|ies) aclocal should search
91: ${AT_M4DIR:=${M4DIR}} 127: ${AT_M4DIR:=}
92AT_GNUCONF_UPDATE="no"
93 128
129# @ECLASS-VARIABLE: AT_SYS_M4DIR
130# @INTERNAL
131# @DESCRIPTION:
132# For system integrators, a list of additional aclocal search paths.
133# This variable gets eval-ed, so you can use variables in the definition
134# that may not be valid until eautoreconf & friends are run.
135: ${AT_SYS_M4DIR:=}
94 136
95# @FUNCTION: eautoreconf 137# @FUNCTION: eautoreconf
96# @DESCRIPTION: 138# @DESCRIPTION:
97# This function mimes the behavior of autoreconf, but uses the different 139# This function mimes the behavior of autoreconf, but uses the different
98# eauto* functions to run the tools. It doesn't accept parameters, but 140# eauto* functions to run the tools. It doesn't accept parameters, but
125 else 167 else
126 _elibtoolize --copy --force 168 _elibtoolize --copy --force
127 fi 169 fi
128 eautoconf 170 eautoconf
129 eautoheader 171 eautoheader
130 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 172 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
131 173
132 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 174 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
133 175
134 # Call it here to prevent failures due to elibtoolize called _before_ 176 # Call it here to prevent failures due to elibtoolize called _before_
135 # eautoreconf. We set $S because elibtoolize runs on that #265319 177 # eautoreconf. We set $S because elibtoolize runs on that #265319
136 S=${PWD} elibtoolize 178 S=${PWD} elibtoolize --force
137 179
138 return 0 180 return 0
181}
182
183# @FUNCTION: eaclocal_amflags
184# @DESCRIPTION:
185# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
186# (most) of the crazy crap that people throw at us.
187eaclocal_amflags() {
188 local aclocal_opts amflags_file
189
190 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
191 [[ -e ${amflags_file} ]] || continue
192 # setup the env in case the pkg does something crazy
193 # in their ACLOCAL_AMFLAGS. like run a shell script
194 # which turns around and runs autotools. #365401
195 # or split across multiple lines. #383525
196 autotools_env_setup
197 aclocal_opts=$(sed -n \
198 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
199 # match the first line
200 s:[^=]*=::p; \
201 # then gobble up all escaped lines
202 : nextline /\\\\$/{ n; p; b nextline; } \
203 }" ${amflags_file})
204 eval aclocal_opts=\""${aclocal_opts}"\"
205 break
206 done
207
208 echo ${aclocal_opts}
139} 209}
140 210
141# @FUNCTION: eaclocal 211# @FUNCTION: eaclocal
142# @DESCRIPTION: 212# @DESCRIPTION:
143# These functions runs the autotools using autotools_run_tool with the 213# These functions runs the autotools using autotools_run_tool with the
144# specified parametes. The name of the tool run is the same of the function 214# specified parametes. The name of the tool run is the same of the function
145# without e prefix. 215# without e prefix.
146# They also force installing the support files for safety. 216# They also force installing the support files for safety.
147# Respects AT_M4DIR for additional directories to search for macro's. 217# Respects AT_M4DIR for additional directories to search for macro's.
148eaclocal() { 218eaclocal() {
149 local aclocal_opts
150
151 local amflags_file
152 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
153 [[ -e ${amflags_file} ]] || continue
154 aclocal_opts=$(sed -n '/^ACLOCAL_AMFLAGS[[:space:]]*=/s:[^=]*=::p' ${amflags_file})
155 eval aclocal_opts=\"${aclocal_opts}\"
156 break
157 done
158
159 if [[ -n ${AT_M4DIR} ]] ; then
160 for x in ${AT_M4DIR} ; do
161 case "${x}" in
162 "-I")
163 # We handle it below
164 ;;
165 *)
166 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
167 aclocal_opts="${aclocal_opts} -I ${x}"
168 ;;
169 esac
170 done
171 fi
172
173 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 219 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
174 autotools_run_tool aclocal "$@" ${aclocal_opts} 220 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
175} 221}
176 222
177# @FUNCTION: _elibtoolize 223# @FUNCTION: _elibtoolize
178# @DESCRIPTION: 224# @DESCRIPTION:
179# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from 225# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
198# @DESCRIPTION: 244# @DESCRIPTION:
199# Runs autoheader. 245# Runs autoheader.
200eautoheader() { 246eautoheader() {
201 # Check if we should run autoheader 247 # Check if we should run autoheader
202 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 248 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
203 NO_FAIL=1 autotools_run_tool autoheader "$@" 249 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
204} 250}
205 251
206# @FUNCTION: eautoconf 252# @FUNCTION: eautoconf
207# @DESCRIPTION: 253# @DESCRIPTION:
208# Runs autoconf. 254# Runs autoconf.
212 eerror "No configure.{ac,in} present in '${PWD}'!" 258 eerror "No configure.{ac,in} present in '${PWD}'!"
213 echo 259 echo
214 die "No configure.{ac,in} present!" 260 die "No configure.{ac,in} present!"
215 fi 261 fi
216 262
217 autotools_run_tool autoconf "$@" 263 autotools_run_tool --at-m4flags autoconf "$@"
218} 264}
219 265
220# @FUNCTION: eautomake 266# @FUNCTION: eautomake
221# @DESCRIPTION: 267# @DESCRIPTION:
222# Runs automake. 268# Runs automake.
224 local extra_opts 270 local extra_opts
225 local makefile_name 271 local makefile_name
226 272
227 # Run automake if: 273 # Run automake if:
228 # - a Makefile.am type file exists 274 # - a Makefile.am type file exists
229 # - a Makefile.in type file exists and the configure
230 # script is using the AM_INIT_AUTOMAKE directive 275 # - the configure script is using the AM_INIT_AUTOMAKE directive
231 for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do 276 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
232 [[ -f ${makefile_name} ]] && break 277 [[ -f ${makefile_name} ]] && break
233 done 278 done
234 [[ -z ${makefile_name} ]] && return 0
235 279
236 if [[ ${makefile_name} == *.in ]] ; then 280 if [[ -z ${makefile_name} ]] ; then
237 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then 281 # Really we should just use autotools_check_macro ...
282 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
283 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
238 return 0 284 return 0
239 fi 285 fi
240 286
241 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then 287 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
242 local used_automake 288 local used_automake
253 eautoreconf 299 eautoreconf
254 return 0 300 return 0
255 fi 301 fi
256 fi 302 fi
257 303
258 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 304 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
259 || extra_opts="${extra_opts} --foreign" 305 || extra_opts="${extra_opts} --foreign"
260 306
261 # --force-missing seems not to be recognized by some flavours of automake 307 # --force-missing seems not to be recognized by some flavours of automake
262 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 308 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
263} 309}
267# Runs autopoint (from the gettext package). 313# Runs autopoint (from the gettext package).
268eautopoint() { 314eautopoint() {
269 autotools_run_tool autopoint "$@" 315 autotools_run_tool autopoint "$@"
270} 316}
271 317
318# @FUNCTION: config_rpath_update
319# @USAGE: [destination]
320# @DESCRIPTION:
321# Some packages utilize the config.rpath helper script, but don't
322# use gettext directly. So we have to copy it in manually since
323# we can't let `autopoint` do it for us.
324config_rpath_update() {
325 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
326
327 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
328 [[ $# -eq 0 ]] && return 0
329
330 einfo "Updating all config.rpath files"
331 for dst in "$@" ; do
332 einfo " ${dst}"
333 cp "${src}" "${dst}" || die
334 done
335}
336
272# Internal function to run an autotools' tool 337# Internal function to run an autotools' tool
273autotools_run_tool() { 338autotools_env_setup() {
274 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
275 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
276 fi
277
278 # We do the latest → version switch here because it solves 339 # We do the "latest" → version switch here because it solves
279 # possible order problems, see bug #270010 as an example. 340 # possible order problems, see bug #270010 as an example.
280 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then 341 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
281 local pv 342 local pv
282 for pv in ${_LATEST_AUTOMAKE} ; do 343 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
283 # has_version respects ROOT, but in this case, we don't want it to, 344 # has_version respects ROOT, but in this case, we don't want it to,
284 # thus "ROOT=/" prefix: 345 # thus "ROOT=/" prefix:
285 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv" 346 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
286 done 347 done
287 [[ ${WANT_AUTOMAKE} == "latest" ]] && \ 348 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
288 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}" 349 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
289 fi 350 fi
290 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5 351 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
352}
353autotools_run_tool() {
354 # Process our own internal flags first
355 local autofail=true m4flags=false
356 while [[ -n $1 ]] ; do
357 case $1 in
358 --at-no-fail) autofail=false;;
359 --at-m4flags) m4flags=true;;
360 # whatever is left goes to the actual tool
361 *) break;;
362 esac
363 shift
364 done
365
366 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
367 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
368 fi
369
370 autotools_env_setup
291 371
292 local STDERR_TARGET="${T}/$1.out" 372 local STDERR_TARGET="${T}/$1.out"
293 # most of the time, there will only be one run, but if there are 373 # most of the time, there will only be one run, but if there are
294 # more, make sure we get unique log filenames 374 # more, make sure we get unique log filenames
295 if [[ -e ${STDERR_TARGET} ]] ; then 375 if [[ -e ${STDERR_TARGET} ]] ; then
376 local i=1
377 while :; do
296 STDERR_TARGET="${T}/$1-$$.out" 378 STDERR_TARGET="${T}/$1-${i}.out"
379 [[ -e ${STDERR_TARGET} ]] || break
380 : $(( i++ ))
381 done
382 fi
383
384 if ${m4flags} ; then
385 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
297 fi 386 fi
298 387
299 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}" 388 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
300 389
301 ebegin "Running $@" 390 ebegin "Running $@"
302 "$@" >> "${STDERR_TARGET}" 2>&1 391 "$@" >> "${STDERR_TARGET}" 2>&1
303 eend $? 392 if ! eend $? && ${autofail} ; then
304
305 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
306 echo 393 echo
307 eerror "Failed Running $1 !" 394 eerror "Failed Running $1 !"
308 eerror 395 eerror
309 eerror "Include in your bugreport the contents of:" 396 eerror "Include in your bugreport the contents of:"
310 eerror 397 eerror
317# Internal function to check for support 404# Internal function to check for support
318autotools_check_macro() { 405autotools_check_macro() {
319 [[ -f configure.ac || -f configure.in ]] || return 0 406 [[ -f configure.ac || -f configure.in ]] || return 0
320 local macro 407 local macro
321 for macro ; do 408 for macro ; do
322 WANT_AUTOCONF="2.5" autoconf --trace="${macro}" 2>/dev/null 409 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
323 done 410 done
324 return 0 411 return 0
325} 412}
326 413
414# Internal function to look for a macro and extract its value
415autotools_check_macro_val() {
416 local macro=$1 scan_out
417
418 autotools_check_macro "${macro}" | \
419 gawk -v macro="${macro}" \
420 '($0 !~ /^[[:space:]]*(#|dnl)/) {
421 if (match($0, macro ":(.*)$", res))
422 print res[1]
423 }' | uniq
424
425 return 0
426}
427
327# Internal function to get additional subdirs to configure 428# Internal function to get additional subdirs to configure
328autotools_get_subdirs() { 429autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
329 local subdirs_scan_out 430autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
330 431
331 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS") 432_autotools_m4dir_include() {
332 [[ -n ${subdirs_scan_out} ]] || return 0 433 local x include_opts
333 434
334 echo "${subdirs_scan_out}" | gawk \ 435 for x in "$@" ; do
335 '($0 !~ /^[[:space:]]*(#|dnl)/) { 436 case ${x} in
336 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res)) 437 # We handle it below
337 print res[1] 438 -I) ;;
338 }' | uniq 439 *)
440 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
441 include_opts+=" -I ${x}"
442 ;;
443 esac
444 done
339 445
340 return 0 446 echo ${include_opts}
341} 447}
448autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
449autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
342 450
343autotools_get_auxdir() { 451fi
344 local auxdir_scan_out
345
346 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
347 [[ -n ${auxdir_scan_out} ]] || return 0
348
349 echo ${auxdir_scan_out} | gawk \
350 '($0 !~ /^[[:space:]]*(#|dnl)/) {
351 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
352 print res[1]
353 }' | uniq
354
355 return 0
356}

Legend:
Removed from v.1.99  
changed lines
  Added in v.1.130

  ViewVC Help
Powered by ViewVC 1.1.20